![https://i.imgur.com/euqFF8l.png](https://i.imgur.com/euqFF8l.png)

### <p align="center">Simple MMO Classes is a [Valheim](https://www.valheimgame.com/) mod that adds a Basic "Vanilla-ish" Class System to the game.</p> 
<p align="center"></p>

## 8 Available Classes:  ** IMMPORTANT ** It is recommended that you use this on a new character, as exsisting characters will already have experience in certain skills, and this will interfer with the leveling system of the Classes.


| Icon                                                                | Class   | Description                                                        |
|:--------------------------------------------------------------------|:--------|:-------------------------------------------------------------------|
| ![https://i.imgur.com/uudpgVM.png](https://i.imgur.com/uudpgVM.png) | Warrior | Tank style class with more HP & extra Stamina.                     |
| ![https://i.imgur.com/uZMbsll.png](https://i.imgur.com/uZMbsll.png) | Paladin | Utility Style Class/Backup Tank (or with mods backup healer).      |
| ![https://i.imgur.com/q04IBNs.png](https://i.imgur.com/q04IBNs.png) | Rogue   | Melee Damage focused sneaky class.                                 |
| ![https://i.imgur.com/DtW19lt.png](https://i.imgur.com/DtW19lt.png) | Hunter  | The ranged version of a Rogue.                                     |
| ![https://i.imgur.com/8eoRjNG.png](https://i.imgur.com/8eoRjNG.png) | Priest  | Seemed silly not to call the "healing class" a priest (needs mods).|
| ![https://i.imgur.com/MqmWhXg.png](https://i.imgur.com/MqmWhXg.png) | Druid   | Similar to the Paladin, a well rounded Utility class.              |
| ![https://i.imgur.com/XZtpxW1.png](https://i.imgur.com/XZtpxW1.png) | Mage    | A mage focuses on Elemental Magic only & has more Eitr.            |
| ![https://i.imgur.com/XDhgr5z.png](https://i.imgur.com/XDhgr5z.png) | Warlock | A Warlock focuses on Blood Magic only & has more Eitr.             |

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
    Recommended Mods to combine with for a Full MMO Experience
</span></b></summary>


| Mod Name              | Usage                                          | Links                                                                                   |
|:----------------------|:-----------------------------------------------|:----------------------------------------------------------------------------------------|
| Wacky's EpicMMO       | Adds attributs like Agility Strength etc.      | https://valheim.thunderstore.io/package/WackyMole/WackyEpicMMOSystem/                   |
| Skyheim               | Provides some class like abilities & powers.   | https://valheim.thunderstore.io/package/makail/Skyheim/                                 |
| Magic Plugin          | Provides some early game magic stuff.          | https://valheim.thunderstore.io/package/blacks7ar/MagicPlugin/                          |
| Professions           | Adds additional Crafting leveling & bonus.     | https://valheim.thunderstore.io/package/Smoothbrain/Professions/                        |
| ItemRequiresSkillLevel| Adds ability to restrict usage of items.       | https://valheim.thunderstore.io/package/Detalhes/ItemRequiresSkillLevel/                |
| KG's Marketplace      | Create custom Quests, Markets, & NPS.          | https://valheim.thunderstore.io/package/KGvalheim/Marketplace_And_Server_NPCs_Revamped/ |
| ServerCharacters      | Syn character file with server - no cheating!  | https://valheim.thunderstore.io/package/Smoothbrain/ServerCharacters/                   |
*Unfortunately there are not any good mods that create powers/abilities/armor/ or weapons for a healing class, but you can kinda patch one together with enough mods.
*We did use Teq's Healing Staff's but that is not working, there is otherwise ONE healing staff in the magic plugin.

And any other mod you can find to add in new skills/powers or weapons!!!

</details>

![https://i.imgur.com/euqFF8l.png](https://i.imgur.com/euqFF8l.png)

## General Information

Simple MMO Classes is a mod that adds classes in Valheim. I am a newer Developer so please bare with me while I am learning things.

In the current release, the classes are modeled after "World of Warcraft" specificlly for the need of my communities server.  However, in future releases the class names will be changed to more reflect the organic theme of Valheim.  This is just "Phase 1".

Phase 1 & 2 Plans: To finish off Phase one, there are 2 bugs that need to be worked out. Detailed below.  For Phase 2, I plan on implimenting SOME abilities down the road, but nothing "game breaking" or outside of a "Vanilla" feel.

Future Plans: If any, or requests come in, I may expand on the number of available classes.

## What is currently working:</h1></b>


* Classes System: You can pick any ONE of the 8 available classes.
* Class Skill Blocking: When you choose a class, it has a determined set of Skills that get blocked from leveling (see info below).
* Level System:  Each Class injects as a "Skill" in the Skill Tree Menu, each Class is assigned 4 "main" skills and those skills will determine the level of the Class.
* Classes are tested in multiplayer and seem to work with no problems.
* Stat Bonuses:  Each Class will give a "Bonus" to your Base HP/Stamina or Eitr, respectively.

## What hasn't been implimented yet:


* Choosing "multiple classes", I honestly do not know if this will be an available feature, so some of the classes "Skill blocking" methods would conflict.
* Switching Classes, I intend to have this functionality available in the "Config file".
* The Config File, It is generated, and Locks for Server Sync, but beyond that I have no idea what the other configurations it generated will actually do, my suggestion, don't bother with the config file at this time.

Please feel free to report all bugs you find to me (discord link below). Also feel free to suggest your ideas as this mod is in early development.



![https://i.imgur.com/euqFF8l.png](https://i.imgur.com/euqFF8l.png)

# Guides

<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
   How to Choose a Class:
</span></b></summary>

To choose a class simply hit the "Tab" key to open your inventory.  This will bring up a box to choose your class,  Once you have chosen a class, this Panel will Disable itself and you will NOT be able to change classes.

![https://i.imgur.com/Z6Cjwyj.png](https://i.imgur.com/Z6Cjwyj.png)


Simply click the icons to see each class:

![https://i.imgur.com/cUyJyhb.png](https://i.imgur.com/cUyJyhb.png)

And then check the box to choose the class:

![https://i.imgur.com/xMHZ3NO.png](https://i.imgur.com/xMHZ3NO.png)

Please note once you choose a class, the panel is locked, and you are done!
You can HIDE / SHOW the panel with this toggle button at the top of your screen:

![https://i.imgur.com/xMHZ3NO.png](https://i.imgur.com/xMHZ3NO.png)

</details>

# Manual Install


>Download the latest copy of Bepinex per author's instructions.

>Place the SimpleMMOClasses Folder inside of the "BepInEx\plugins\" folder.

## Known Bugs/Issues/Incompatabilitiles

* The Class Selection Panel can be opened at the start of the game in the Main Menu.  Doing so will "glitch" the panel & lock the class system and prevent you from selecting or using your class.  DO NOT HIT TAB WHILE IN THE MAIN MENU, otherwise you WILL need to close Valheim and re-open it.
* Once you have created a Character & Chose a Class, in order to "switch characters", you need to close valheim and reopen it, otherwise the Class Panel will glitch and your Character will not have the correct Class.
* This "Warning" will appear either when first opening Valheim, Creating a New Character, or Loading a saved character.  This warning as far as I can tell right now refers to the bugs listed above but otherwise causes no issues.
```
[Warning: Unity Log] Error loading player data: C:/Users/USERNAME/AppData/LocalLow/IronGate/Valheim/characters_local/CHARACTERNAME.fch, error: Object reference not set to an instance of an object"
```


<details>
  <summary><b><span style="color:aqua;font-weight:200;font-size:20px">
    Patchnotes
</span></b></summary>

| Version Number | Change(s)                                                                                                                                      |
|:---------------|:-----------------------------------------------------------------------------------------------------------------------------------------------|
| v1.0.5         | Fixed caused a bug, its fixed.. oops.                                                                                                          |
| v1.0.4         | Fixed issue with Classes not leveling at the expected rate.                                                                                    |
| v1.0.3         | New button in new location, reports that wider screen monitors was loosing the button.  Also fixed some leveling issues with Hunters.          |
|                | additional restrictions for "Classess" (not choosing a class), to Block BloodMagic & ElementalMagic skill entirely.                            |
| v1.0.2         | Unreleased - attempted to make buttom moveable, did not work, had to roll back.                                                                |
| v1.0.1         | Repaired Warlock's leveling & added new "hide/show" button & removed X for closing menu.  It is now more inutiative and out of the way         |
| v1.0.0         | Testing Release                                                                                                                                |

</details>


For Questions or Comments, find GGrNoob in the Odin Plus
Team Discord, or Join my Growing Community!
[![https://i.imgur.com/XXP6HCU.png](https://i.imgur.com/XXP6HCU.png)](https://discord.gg/5gXNxNkUBt)

Join my Gorwing Community!  The Hideout: https://discord.gg/J2T8YvBRaQ

If you enjoy this mod and want to support me or my community, Buy us a Coffee: https://bmc.link/ggrnoob